| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Private Attributes | List of all members
ArrayNDProbDenFunc Class Referenceabstract
Algo

PDF based on ArrayND implementation. More...

`#include <sampledprobdenfunc.h>`

Inheritance diagram for ArrayNDProbDenFunc:
[legend]

## Public Member Functions
virtual | ~ArrayNDProbDenFunc ()
void | fillPar (IOPar &) const
ArrayND< float > * | getArrClone () const
float | getAveragePos (int dim) const
ArrayND< float > & | getData ()
const ArrayND< float > & | getData () const
Interval< float > | getRange (int dim) const
bool | hasCachedAveragePos () const
ArrayNDProbDenFunc & | operator= (const ArrayNDProbDenFunc &)
bool | readBulkData (od_istream &, bool)
SamplingData< float > & | sampling (int dim)
const SamplingData< float > & | sampling (int dim) const
void | setRange (int dim, const StepInterval< float > &)
bool | setSize (const int *, int sz)
bool | setSize (const TypeSet< int > &)
int | size (int dim) const
od_uint64 | totalSize () const
bool | usePar (const IOPar &)
void | writeBulkData (od_ostream &, bool) const

## Static Public Member Functions
static float | findAveragePos (const float *, int, float grandtotal)
static const char * | sKeyAvgPos ()

## Protected Member Functions
| ArrayNDProbDenFunc (const ArrayNDProbDenFunc &)
| ArrayNDProbDenFunc (int nrdims)
virtual void | doScale (float)
void | fillCumBins () const
virtual const ArrayND< float > & | getArrND () const =0
od_uint64 | getBinPos (float) const
virtual float | getNormFac () const
od_uint64 | getRandBin () const
virtual bool | gtIsEq (const ProbDenFunc &) const
int | nrDims_ () const
void | prepRndDrw () const

## Protected Attributes
float * | cumbins_ = nullptr
Stats::RandomGenerator & | gen_

## Private Member Functions
const SamplingData< float > & | getSampling (int) const

## Private Attributes
TypeSet< float > | avgpos_
TypeSet< SamplingData< float > > | sds_

## Detailed Description

PDF based on ArrayND implementation.

This interface should allow read/write generalized from disk.

<>

## Constructor & Destructor Documentation

## ◆ ~ArrayNDProbDenFunc()

virtual ArrayNDProbDenFunc::~ArrayNDProbDenFunc | ( |  | ) |
| virtual

## ◆ ArrayNDProbDenFunc() [1/2]

ArrayNDProbDenFunc::ArrayNDProbDenFunc | ( | int | nrdims | ) |
| protected

## ◆ ArrayNDProbDenFunc() [2/2]

ArrayNDProbDenFunc::ArrayNDProbDenFunc | ( | const ArrayNDProbDenFunc & |  | ) |
| protected

## Member Function Documentation

## ◆ doScale()

virtual void ArrayNDProbDenFunc::doScale | ( | float |  | ) |
| protected virtual

## ◆ fillCumBins()

void ArrayNDProbDenFunc::fillCumBins | ( |  | ) | const
| protected

## ◆ fillPar()

void ArrayNDProbDenFunc::fillPar | ( | IOPar & |  | ) | const

## ◆ findAveragePos()

static float ArrayNDProbDenFunc::findAveragePos | ( | const float * | ,
|  | int | ,
|  | float | grandtotal )
| static

## ◆ getArrClone()

ArrayND< float > * ArrayNDProbDenFunc::getArrClone | ( |  | ) | const

## ◆ getArrND()

virtual const ArrayND< float > & ArrayNDProbDenFunc::getArrND | ( |  | ) | const
| protected pure virtual

Implemented in Sampled1DProbDenFunc, Sampled2DProbDenFunc, and SampledNDProbDenFunc.

## ◆ getAveragePos()

float ArrayNDProbDenFunc::getAveragePos | ( | int | dim | ) | const

## ◆ getBinPos()

od_uint64 ArrayNDProbDenFunc::getBinPos | ( | float |  | ) | const
| protected

## ◆ getData() [1/2]

ArrayND< float > & ArrayNDProbDenFunc::getData | ( |  | ) |
| inline

## ◆ getData() [2/2]

const ArrayND< float > & ArrayNDProbDenFunc::getData | ( |  | ) | const
| inline

## ◆ getNormFac()

virtual float ArrayNDProbDenFunc::getNormFac | ( |  | ) | const
| protected virtual

## ◆ getRandBin()

od_uint64 ArrayNDProbDenFunc::getRandBin | ( |  | ) | const
| protected

## ◆ getRange()

Interval< float > ArrayNDProbDenFunc::getRange | ( | int | dim | ) | const

## ◆ getSampling()

const SamplingData< float > & ArrayNDProbDenFunc::getSampling | ( | int |  | ) | const
| private

## ◆ gtIsEq()

virtual bool ArrayNDProbDenFunc::gtIsEq | ( | const ProbDenFunc & |  | ) | const
| protected virtual

## ◆ hasCachedAveragePos()

bool ArrayNDProbDenFunc::hasCachedAveragePos | ( |  | ) | const

## ◆ nrDims_()

int ArrayNDProbDenFunc::nrDims_ | ( |  | ) | const
| inline protected

## ◆ operator=()

ArrayNDProbDenFunc & ArrayNDProbDenFunc::operator= | ( | const ArrayNDProbDenFunc & |  | ) |

## ◆ prepRndDrw()

void ArrayNDProbDenFunc::prepRndDrw | ( |  | ) | const
| protected

## ◆ readBulkData()

bool ArrayNDProbDenFunc::readBulkData | ( | od_istream & | ,
|  | bool | )

## ◆ sampling() [1/2]

SamplingData< float > & ArrayNDProbDenFunc::sampling | ( | int | dim | ) |

## ◆ sampling() [2/2]

const SamplingData< float > & ArrayNDProbDenFunc::sampling | ( | int | dim | ) | const
| inline

## ◆ setRange()

void ArrayNDProbDenFunc::setRange | ( | int | dim,
|  | const StepInterval< float > & | )

## ◆ setSize() [1/2]

bool ArrayNDProbDenFunc::setSize | ( | const int * | ,
|  | int | sz )

## ◆ setSize() [2/2]

bool ArrayNDProbDenFunc::setSize | ( | const TypeSet< int > & |  | ) |

## ◆ size()

int ArrayNDProbDenFunc::size | ( | int | dim | ) | const
| inline

## ◆ sKeyAvgPos()

static const char * ArrayNDProbDenFunc::sKeyAvgPos | ( |  | ) |
| static

## ◆ totalSize()

od_uint64 ArrayNDProbDenFunc::totalSize | ( |  | ) | const
| inline

## ◆ usePar()

bool ArrayNDProbDenFunc::usePar | ( | const IOPar & |  | ) |

## ◆ writeBulkData()

void ArrayNDProbDenFunc::writeBulkData | ( | od_ostream & | ,
|  | bool | ) const

## Member Data Documentation

## ◆ avgpos_

TypeSet<float> ArrayNDProbDenFunc::avgpos_
| mutable private

## ◆ cumbins_

float* ArrayNDProbDenFunc::cumbins_ = nullptr
| mutable protected

## ◆ gen_

Stats::RandomGenerator& ArrayNDProbDenFunc::gen_
| protected

## ◆ sds_

TypeSet<SamplingData<float> > ArrayNDProbDenFunc::sds_
| private

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025